---------------------------------------------------------------------------------------------------
--
--  AUDIO_PWM1.VHDL
--
--  8-Bit D/A PWM
--
--  Autor : Rene Bllhoff
--  Datum : 27.09.2005
--
--  (c) 2005 by Rene Bllhoff
--
---------------------------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity audio_pwm1 is
   port (	clk50m 	: in	std_logic;
	 				res			: in  std_logic;

					newdata : out std_logic;																	 	
					dataout : in  std_logic_vector (7 downto 0);

					pwmout	: out std_logic
				);
end audio_pwm1;

architecture Behavioral of audio_pwm1 is

  signal precount : std_logic_vector (1 downto 0);
  signal pcount   : std_logic_vector (7 downto 0);
	signal pvalue		: std_logic_vector (7 downto 0);

begin

	process (clk50m, res)
	begin
	  if res = '1' then
      precount <= (others => '0'); 
			pcount 	 <= (others => '0');
			pvalue 	 <= X"80";
			pwmout 	 <= '0';

		elsif clk50m'event and clk50m = '1' then

  		-- pwm - handler
			pcount <= pcount + '1';
			if pcount >= pvalue then
			  pwmout <= '0';
			else
				pwmout <= '1';
			end if;

			-- neue daten bernehmen
			if pcount <= X"00" then
				precount <= precount + '1';
				-- prescaler fr neue datenbernahme
				if precount = "00" then
					newdata <= '1';
					pvalue  <= dataout;
				end if;
			else
				newdata <= '0';
			end if;


		end if;

	end process;

end Behavioral;
