---------------------------------------------------------------------------------------------------
--
--  EDGE_DETECT.VHDL
--
--  Flankenerkennung (per Sampling)
--
--  Autor : Rene Bllhoff
--  Datum : 27.05.2005
--
--  (c) 2005 by Rene Bllhoff
--
---------------------------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;



entity edge_detect is
    Port ( clk50m : in std_logic;
					 res		: in std_logic;	
					 edge		: in std_logic;   -- welche flanke
					 i 			: in std_logic;
           o 			: out std_logic);
end edge_detect;

architecture Behavioral of edge_detect is
	signal edge_z1 : std_logic;
begin
  process (clk50m, res, i)
	begin
	  if res = '1' then
			edge_z1 <= '0';
			o				<= '0';
		elsif clk50m'event and (clk50m = '1') then
			-- flankenerkennung (edge = 1 pos ; edge = 0 neg)
			if edge = '1' then
				if i = '1' and edge_z1 = '0' then
					o <= '1';
				else
				  o <= '0';
				end if;
			else
				if i = '0' and edge_z1 = '1' then
					o <= '1';
				else
				  o <= '0';
				end if;
			end if;
			edge_z1 <= i;		 -- aktuellen wert speichern (fr erkennung)
		end if;

	end process;

end Behavioral;
